
/* ###--------------------------------------------------------------### */
/*																		*/
/* file		: syf_utdef.h												*/
/* date		: Jun 18 1992												*/
/* version	: v100														*/
/* author	: L.A.TABUSSE												*/
/* content	: declaration of external functions and global variables	*/
/*		  used by yacc													*/
/*																		*/
/* ###--------------------------------------------------------------### */
#define SYF_ICNDFN     1                /* input        port             */
#define SYF_OCNDFN     2                /* output       port             */
#define SYF_BCNDFN     3                /* inout        port             */
#define SYF_CSTDFN     4                /* constant                      */
#define SYF_TPEDFN     5                /* type                          */
#define SYF_SGNDFN     6                /* signal                        */
#define SYF_STBDFN     7                /* stable's signal               */
#define SYF_VARDFN     7                /* variable                      */

#define SYF_BITDFN     8                /* bit          type             */
#define SYF_MUXDFN    16                /* mux_bit      type             */
#define SYF_WORDFN    24                /* wor_bit      type             */
#define SYF_RBIDFN    32                /* reg_bit      type             */
#define SYF_BTVDFN    40                /* bit_vector   type             */
#define SYF_MXVDFN    48                /* mux_vector   type             */
#define SYF_WRVDFN    56                /* wor_vector   type             */
#define SYF_RGVDFN    64                /* reg_vector   type             */
#define SYF_NATDFN    88                /* natural      type             */
#define SYF_NTVDFN    96                /* nat_vector   type             */

#define SYF_NORDFN   128                /* non guarded  signal           */
#define SYF_BUSDFN   256                /* guarded      signal (bus)     */
#define SYF_REGDFN   384                /* guarded      signal (register)*/

#define SYF_MODDFN     0                /* mod_val field of dct_recrd    */
#define SYF_SIGDFN     1                /* sig_val field of dct_recrd    */
#define SYF_TYPDFN     2                /* type_val field of dct_recrd    */
#define SYF_USRDFN     3                /* user_val field of dct_recrd    */
#define SYF_LBLDFN     4                /* lbl_val field of dct_recrd    */
#define SYF_WMXDFN     5                /* wmx_val field of dct_recrd    */
#define SYF_WMNDFN     6                /* wmn_val field of dct_recrd    */
#define SYF_PNTDFN     7                /* pnt_val field of dct_recrd    */

#define SYF_NAMDFN 0
#define SYF_NEWDFN 1

#define SYF_ALODFN     60		/* minimal size of allocation	 */
					/* for dct_entry and dct_recrd	 */
#define SYF_HSZDFN     97		/* number of entry points in the */
					/* dictionnary			 */
#define SYF_MXRDFN 30
